// radar script for E-2 idea

// Use _targets = _awacs targetsQuery [objNull, sideUnknown, "", [], 0]; to get all targets and push them to map


ttt_awacs_displayMarker = {
	params ["_target"];
	private _newTarget = false;
	_target params ["_acc", "_tgt", "_side", "_type", "_pos", "_age"];
	// [accuracy, target, targetSide, targetType, targetPosition, targetAge]
	if ( (_tgt getVariable ["ttt_marker", ""]) isEqualTo "" ) then {
		// creat new marker
		private _mrkr = createMarker [str ttt_targetNumber, _pos];
		ttt_targetNumber = ttt_targetNumber + 1;
		// TODO: icon by type
		_mrkr setMarkerType "mil_unknown";
		// TODO: color by side
		_mrkr setMarkerColor "ColorWhite";
		switch (_side) do {
			case east: { _mrkr setMarkerColor "ColorRed"; _mrkr setMarkerType "o_unknown"; };
			case west: { _mrkr setMarkerColor "ColorBlue"; _mrkr setMarkerType "b_unknown"; };
			case independent: { _mrkr setMarkerColor "ColorGreen"; _mrkr setMarkerType "n_unknown"; };
			case civilian: { _mrkr setMarkerColor "ColorPurple"; };
		};
		private _typeString = getText (configFile >> "CfgVehicles" >> _type >> "displayName");
		_mrkr setMarkerText format ["%1 %2", _typeString, floor(getPos _tgt # 2)];
		_tgt setVariable ["ttt_marker", _mrkr];
		_newTarget = true;
	} else {
		// use existing marker
		private _mrkr = _tgt getVariable "ttt_marker";
		_mrkr setMarkerPos _pos;
		private _typeString = getText (configFile >> "CfgVehicles" >> _type >> "displayName");
		_mrkr setMarkerText format ["%1 %2", _typeString, floor(getPos _tgt # 2)];
		if (!alive _tgt or {_age > 300}) then {
			_mrkr setMarkerColor "ColorBlack";
		};
	};
	_newTarget;
};

ttt_awacs_eligibleTarget = {
	params ["_target"];
	_target params ["_acc", "_tgt", "_side", "_type", "_pos", "_age"];
	_ret = false;
	if (speed _tgt > ttt_awacsMinSpeed and {getPosATL _tgt # 2 > ttt_awacsMinHeight} and {alive _tgt}) then {
		_ret = true;
	} else {
		// track vehicles with radar on
		if (isVehicleRadarOn _tgt) then {
			_ret = true;
		} else {
			// check if non eligible has a marker assigned
			if ( !((_tgt getVariable ["ttt_marker", ""]) isEqualTo "") ) then {
				// remove existing marker on non eligible target
				deleteMarker (_tgt getVariable "ttt_marker");
				_tgt setVariable ["ttt_marker", nil];
			};
		};
	};
	_ret;
};


ttt_awacsList = [];
ttt_awacsList pushBackUnique awacs;
ttt_awacsLastUpdate = time;
ttt_targetNumber = 1;
// configurable
// Update of map based on targets detected by awacs, in seconds
ttt_awacsUpdateFreq = 5;
// minimum speed in kmh
ttt_awacsMinSpeed = 10;
// minimum height in meters
ttt_awacsMinHeight = 20;

[ "ttt_awacs_000", "onEachFrame",
{
	if (time > ttt_awacsLastUpdate + ttt_awacsUpdateFreq) then {
		ttt_awacsLastUpdate = time;
		{
			private _awacs = _x;
	  		if (alive _awacs) then {
	  			if (isVehicleRadarOn _awacs) then {
		  			private _targets = (driver _awacs) targetsQuery [objNull, sideUnknown, "", [], 0];
		  			_targets = _targets - [_awacs];
		  			private _trackedTargets = 0;
		  			{
		  				if ([_x] call ttt_awacs_eligibleTarget) then {
		  					_trackedTargets = _trackedTargets + 1;
			  				if ([_x] call ttt_awacs_displayMarker) then {
			  					_awacs sideChat format ["Tracking new target %1 %2", _awacs getDir (_x # 4), _awacs distance (_x # 4)];
			  				};
			  			};
			  		} forEach _targets;
		  			// _awacs vehicleChat format ["Tracking %1 targets", _trackedTargets];
			  	};
		  	} else {
		  		ttt_awacsList = ttt_awacsList - [_awacs];
		  		// cleanup ttt_marker
		  		{
		  			if (!(_x getVariable ["ttt_marker", ""] isEqualTo "")) then {
		  				deleteMarker (_x getVariable "ttt_marker");
			  			_x setVariable ["ttt_marker", nil];
			  		};
		  		} forEach vehicles;
			};

		} forEach (missionNamespace getVariable ["ttt_awacsList", []]);
	};
}
] call BIS_fnc_addStackedEventHandler;

awacs setVehicleRadar 1;
